% LICENSE CONDITIONS
% ==================================
% 
% Copyright   2012   The Regents of the University of California
% All Rights Reserved
% 
% Permission to use, copy, modify and distribute any part of this 
% code for training multicalss classifers for educational, research 
% and non-profit purposes, without fee, and without a written 
% agreement is hereby granted, provided that the above copyright 
% notice, this paragraph and the following three paragraphs appear 
% in all copies.
% 
% Those desiring to incorporate this code for MCBoost(GD or CD )
% into commercial products or use for commercial purposes 
% should contact the Technology Transfer & Intellectual Property 
% Services, University of California, San Diego, 9500 Gilman Drive, 
% Mail Code 0910, La Jolla, CA 92093-0910, Ph: (858) 534-5815, 
% FAX: (858) 534-7345, E-MAIL:invent@ucsd.edu.
% 
% IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE 
% TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, 
% OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS, 
% ARISING OUT OF THE USE OF THIS CODE FOR MCBOOST,  
% EVEN IF THE UNIVERSITY OF CALIFORNIA 
% HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
% 
% THE CODE FOR MCBOOST PROVIDED 
% HEREIN IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF 
% CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
% SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.  
% THE UNIVERSITY OF CALIFORNIA MAKES NO REPRESENTATIONS 
% AND EXTENDS NO WARRANTIES OF ANY KIND, EITHER IMPLIED 
% OR EXPRESS, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
% WARRANTIES OF MERCHANTABILITY OR FITNESS FOR 
% A PARTICULAR PURPOSE, OR THAT THE USE OF THE 
% CODE FOR DISCRIMINANT SALIENCY TRACKER WILL NOT 
% INFRINGE ANY PATENT, TRADEMARK OR OTHER RIGHTS.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

close all
clear all
clc

SS='synt3';
N=1000;

i=1;
mu(i,:) = [1 2];
Sigma(:,:,i) = [1 .5; .5 2]; R1 = chol(Sigma(:,:,i));
z1 = repmat(mu(i,:),N,1) + randn(N,2)*R1;
Y1=ones(N,1);
plot(z1(:,1),z1(:,2),'.');
hold on 



i=2;
mu(i,:) = [-1 0];
Sigma(:,:,i) = [1 .3; .3 1]; R1 = chol(Sigma(:,:,i));
z2 = repmat(mu(i,:),N,1) + randn(N,2)*R1;
Y2=2*ones(N,1);
plot(z2(:,1),z2(:,2),'r.');



i=3;
mu(i,:) = [2  -1];
Sigma(:,:,i) = [.4 .1; .1 .8]; R1 = chol(Sigma(:,:,i));
z3 = repmat(mu(i,:),N,1) + randn(N,2)*R1;
Y3=3*ones(N,1);
plot(z3(:,1),z3(:,2),'g.');
hold off


XF=[z1;z2;z3];
Y=[Y1;Y2;Y3];

for j=1:3
    M(j,:)=mvnpdf(XF,mu(j,:),Sigma(:,:,j));
end
   
[p,q]=max(M);
Bayes_accu=sum(Y==q')/(3*N);

disp('Stats:')
disp(['Number of classes: 3'])
disp(['Number point examples per class: ' num2str(N)]);
disp(['Bayes error rate: ' num2str(1-Bayes_accu)])

N_class=3;
XFv=XF;
Yv=Y;
Bayes_errv=1-Bayes_accu;
save(['test_' SS],'XFv','Yv','N_class','Bayes_errv');
save(['Stats_test_' SS]);

