function main
% LICENSE CONDITIONS
% ==================================
% 
% Copyright   2012   The Regents of the University of California
% All Rights Reserved
% 
% Permission to use, copy, modify and distribute any part of this 
% code for training multicalss classifers for educational, research 
% and non-profit purposes, without fee, and without a written 
% agreement is hereby granted, provided that the above copyright 
% notice, this paragraph and the following three paragraphs appear 
% in all copies.
% 
% Those desiring to incorporate this code for MCBoost(GD or CD )
% into commercial products or use for commercial purposes 
% should contact the Technology Transfer & Intellectual Property 
% Services, University of California, San Diego, 9500 Gilman Drive, 
% Mail Code 0910, La Jolla, CA 92093-0910, Ph: (858) 534-5815, 
% FAX: (858) 534-7345, E-MAIL:invent@ucsd.edu.
% 
% IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE 
% TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, 
% OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS, 
% ARISING OUT OF THE USE OF THIS CODE FOR MCBOOST,  
% EVEN IF THE UNIVERSITY OF CALIFORNIA 
% HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
% 
% THE CODE FOR MCBOOST PROVIDED 
% HEREIN IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF 
% CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
% SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.  
% THE UNIVERSITY OF CALIFORNIA MAKES NO REPRESENTATIONS 
% AND EXTENDS NO WARRANTIES OF ANY KIND, EITHER IMPLIED 
% OR EXPRESS, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
% WARRANTIES OF MERCHANTABILITY OR FITNESS FOR 
% A PARTICULAR PURPOSE, OR THAT THE USE OF THE 
% CODE FOR DISCRIMINANT SALIENCY TRACKER WILL NOT 
% INFRINGE ANY PATENT, TRADEMARK OR OTHER RIGHTS.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%=================Loading data and weak learners ==========================
SS='synt3';
loc= ['Data/' SS '/'];

load([loc 'wlearner_' SS]);
load([loc 'train_' SS]);
load([loc 'test_' SS]); 
%========initialization of CD_MCBoost======================================
N=N_class;
dim=N-1;
Tf=200;
level_len=zeros(1,dim);
temp_a.num=1;    temp_a.thr=1;    temp_a.c=1;    temp_a.b=1;
F=temp_a;
stp=1;
Yc=ones(size(Y))/1000;
Ycv=ones(size(Yv))/1000;
fname=sprintf('CD_MCBoost_%s',SS);
%========Loading codewords ================================================

[Y_cmp,Y_disp,Y_lab,Z_lab]=clac_vectors3(Y,N,dim);
[Y_cmp,Y_disp,Yv_lab,Zv_lab]=clac_vectors3(Yv,N,dim);
%============CD-MCBoost Algorithm =========================================
for i=stp:Tf
    f_val=stageevals(F,XF,f,level_len);
    Plot_Point2(f_val,Y_disp,N,Y_cmp,Y);
    for j=1:dim
        J=J_comp(f_val,Z_lab,Yc,j);
        [Up(j), Ang(i,j), fx]=best_feature(J,XF,f);
%         alpha(i,j)=best_step(f_val,Z_lab,fx,Yc,j);
        alpha(i,j)=best_step_bin(f_val,Z_lab,fx,Yc,j);
        Up(j).c=Up(j).c*alpha(i,j);
        level_len(j)=level_len(j)+1;
        F(j,level_len(j))=Up(j);
        f_val=stageevals(F,XF,f,level_len);
    end
    %======================================================================
    [resul(:,i),L(i)]=testermulti(f_val,Y_lab,Z_lab,Yc,Y_cmp,Y);
    fv_val=stageevals(F,XFv,f,level_len);
    [resulv(:,i),Lv(i)]=testermulti(fv_val,Yv_lab,Zv_lab,Ycv,Y_cmp,Yv);
    fprintf('Itr: %d, %s%.2f, %s%.2f\n',i, 'Error on Test Set: ', resulv(2,i), 'Error on Training Set: ', resul(2,i));
    save(fname,'F','resul','level_len','resulv','L','Lv','Ang')
    pause(0.1)
end

    