function main 
% LICENSE CONDITIONS
% ==================================
% 
% Copyright   2012   The Regents of the University of California
% All Rights Reserved
% 
% Permission to use, copy, modify and distribute any part of this 
% code for training multicalss classifers for educational, research 
% and non-profit purposes, without fee, and without a written 
% agreement is hereby granted, provided that the above copyright 
% notice, this paragraph and the following three paragraphs appear 
% in all copies.
% 
% Those desiring to incorporate this code for MCBoost(GD or CD )
% into commercial products or use for commercial purposes 
% should contact the Technology Transfer & Intellectual Property 
% Services, University of California, San Diego, 9500 Gilman Drive, 
% Mail Code 0910, La Jolla, CA 92093-0910, Ph: (858) 534-5815, 
% FAX: (858) 534-7345, E-MAIL:invent@ucsd.edu.
% 
% IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE 
% TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, 
% OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS, 
% ARISING OUT OF THE USE OF THIS CODE FOR MCBOOST,  
% EVEN IF THE UNIVERSITY OF CALIFORNIA 
% HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
% 
% THE CODE FOR MCBOOST PROVIDED 
% HEREIN IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF 
% CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
% SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.  
% THE UNIVERSITY OF CALIFORNIA MAKES NO REPRESENTATIONS 
% AND EXTENDS NO WARRANTIES OF ANY KIND, EITHER IMPLIED 
% OR EXPRESS, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
% WARRANTIES OF MERCHANTABILITY OR FITNESS FOR 
% A PARTICULAR PURPOSE, OR THAT THE USE OF THE 
% CODE FOR DISCRIMINANT SALIENCY TRACKER WILL NOT 
% INFRINGE ANY PATENT, TRADEMARK OR OTHER RIGHTS.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%==================load data and weak learners ============================
SS='satimg';                % database name
disp (['Dataset name : ' SS ])
loc= ['Data/' SS '/'];
load([loc 'train_' SS]);
load([loc 'test_' SS]);
f=eye(size(XF,2));
%========initialization====================================================
max_depth=2;                % maximum depth of the tree
N_search=10;                % precision of the search in building trees 
                            % higher N_search will results in finer search
Tf=50;                      % number of iterations.
level_len = 0;
f_Node.att=1; f_Node.thr=1;f_Node.more=1;f_Node.less=1;f_Node.empt=0;
T=f_Node;
F.T=T;
F.alpha=1;
stp=1;
Yc=ones(size(Y))/1000;
Ycv=ones(size(Yv))/1000;
b=ones(length(XF),1);
fname=sprintf('GD_MCBoost_Tree_Err_%s',SS);
%=========== Loading codewords ============================================
N=N_class;
dim=N-1;
[Y_cmp,Y_disp,Y_lab,Z_lab]=clac_vectors3(Y,N,dim);
[Y_cmp,Y_disp,Yv_lab,Zv_lab]=clac_vectors3(Yv,N,dim);
%=========== GD_MCBoost algorithm =========================================
f_val=Forest_eval_MW(F,XF,f,level_len,N,Y_disp);
fv_val=Forest_eval_MW(F,XFv,f,level_len,N,Y_disp);
for i=stp:Tf         
    J=J_comp_MW(f_val,Z_lab,Yc,j);
    T=build_tree_ERR_MW(T,XF,Y,J',max_depth,1,f,N_search,1,Y_disp);
    fx=eval_tree_MW(T,XF,f,Y_disp);
    alpha(i)=best_step_bin_MW(f_val,Z_lab,fx,Yc);
    level_len=level_len+1;
    F(level_len).T=T;
    F(level_len).alpha=alpha(i);

    f_val=f_val+alpha(i)*fx;
    [resul(:,i),L(i)]=testermulti(f_val,Y_lab,Z_lab,Yc,Y_cmp,Y);    
    fxv=eval_tree_MW(T,XFv,f,Y_disp);
    fv_val=fv_val+alpha(i)*fxv;
    [resulv(:,i), Lv(i)]=testermulti(fv_val,Yv_lab,Zv_lab,Ycv,Y_cmp,Yv);
    fprintf('Itr: %d, %s%.2f, %s%.2f\n',i, 'Error on Test Set: ', resulv(2,i), 'Error on Training Set: ', resul(2,i));
    save(fname,'F','resul','level_len','resulv','L','Lv');
    T(1:end)=[];
end

    